local Player = ...
assert(Player,"[ScreenEvaluation PlayerFrame] requires Player")

local function MakeLabel(text)
	return Def.ActorFrame{
		LoadFont("_eurostile bold 24px")..{
			InitCommand=function(self)
				self:zoom(0.5)
				self:halign(0)
				-- maxcombo uses maxwidth,130; nothing else does.
				if text == "Max Combo" then self:maxwidth(130) end
			end;
			-- xxx: use localized strings instead
			BeginCommand=cmd(settext,text);
		};
	};
end

return Def.ActorFrame{
	LoadActor(THEME:GetPathG("_eval frame","base"));
	LoadActor(THEME:GetPathG("_eval frame","graph"))..{
		InitCommand=cmd(y,-27;);
	};
	LoadActor(THEME:GetPathG("_eval frame","judge"))..{
		InitCommand=cmd(xy,-73,70;);
	};
	LoadActor(THEME:GetPathG("_eval frame","details"))..{
		InitCommand=cmd(xy,65,70;);
	};

	-- labels
	Def.ActorFrame{
		Name="LabelColumn1";
		InitCommand=cmd(xy,-128,31);
		MakeLabel("Fantastic")..{ InitCommand=cmd(y,0;); };
		MakeLabel("Excellent")..{ InitCommand=cmd(y,16;); };
		MakeLabel("Great")..{ InitCommand=cmd(y,16*2;); };
		MakeLabel("Decent")..{ InitCommand=cmd(y,16*3;); };
		MakeLabel("Way Off")..{ InitCommand=cmd(y,16*4;); };
		MakeLabel("Miss")..{ InitCommand=cmd(y,16*5;); };
	};
	Def.ActorFrame{
		Name="LabelColumn2";
		InitCommand=cmd(xy,4,31);
		MakeLabel("Jumps")..{ InitCommand=cmd(y,0;); };
		MakeLabel("Holds")..{ InitCommand=cmd(y,16;); };
		MakeLabel("Mines")..{ InitCommand=cmd(y,16*2;); };
		MakeLabel("Hands")..{ InitCommand=cmd(y,16*3;); };
		MakeLabel("Rolls")..{ InitCommand=cmd(y,16*4;); };
		MakeLabel("Max Combo")..{ InitCommand=cmd(y,16*5;); };
	};
};