local Player = ...
assert(Player,"ScreenSelectMusic PaneDisplay needs a player")

--local xZoom = Player == PLAYER_2 and -1 or 1

local function MakePaneItem(cat,col)
	local valueX = col == 1 and 0 or -16
	return Def.ActorFrame{
		LoadFont("_eurostile bold 24px")..{
			Name="Label-"..cat;
			InitCommand=cmd(x,-96;halign,0;shadowlength,1;zoom,0.5);
			BeginCommand=cmd(settext,THEME:GetString("RadarCategories",ToEnumShortString(cat)));
		};
		LoadFont("_eurostile bold 24px")..{
			Name="Value-"..cat;
			InitCommand=cmd(x,valueX;halign,1;shadowlength,1;zoom,0.5);
			SetCommand=function(self)
				local song = SongOrCourse()
				if song then
					local steps = StepsOrTrail(Player)
					if steps then
						local rv = steps:GetRadarValues(Player)
						local v = rv:GetValue(cat)
						self:settext(v)
					else
						self:settext("?")
					end
				else
					self:settext("?")
				end
			end;
			CurrentSongChangedMessageCommand=cmd(playcommand,"Set");
			CurrentCourseChangedMessageCommand=cmd(playcommand,"Set");
				CurrentStepsP1ChangedMessageCommand=function(self) if Player == PLAYER_1 then self:playcommand("Set") end end;
				CurrentTrailP1ChangedMessageCommand=function(self) if Player == PLAYER_1 then self:playcommand("Set") end end;
				CurrentStepsP2ChangedMessageCommand=function(self) if Player == PLAYER_2 then self:playcommand("Set") end end;
				CurrentTrailP2ChangedMessageCommand=function(self) if Player == PLAYER_2 then self:playcommand("Set") end end;
		};
	};
end

return Def.ActorFrame{
	LoadActor(THEME:GetPathG("_panedisplay","frame"))..{
		--InitCommand=cmd(zoomx,xZoom);
	};
	MakePaneItem('RadarCategory_TapsAndHolds',1)..{
		InitCommand=cmd(xy,-36,-24;);
	};
	MakePaneItem('RadarCategory_Holds',1)..{
		InitCommand=cmd(xy,-36,-10;);
	};
	-- ???
	-- card

	MakePaneItem('RadarCategory_Jumps',2)..{
		InitCommand=cmd(xy,68,-24;);
	};
	MakePaneItem('RadarCategory_Mines',2)..{
		InitCommand=cmd(xy,68,-10;);
	};
	MakePaneItem('RadarCategory_Hands',2)..{
		InitCommand=cmd(xy,68,4;);
	};
	MakePaneItem('RadarCategory_Rolls',2)..{
		InitCommand=cmd(xy,68,18;);
	};
};