local t = Def.ActorFrame{};

t[#t+1] = StandardDecorationFromFile("LifeFrame","LifeFrame")
t[#t+1] = StandardDecorationFromFile("ScoreFrame","ScoreFrame")

t[#t+1] = StandardDecorationFromFile("SongMeter","SongMeter")
t[#t+1] = StandardDecorationFromFileOptional("NowPlaying","NowPlaying")
t[#t+1] = StandardDecorationFromFileOptional("StageDisplay","StageDisplay")
t[#t+1] = StandardDecorationFromFileOptional("CourseMeter","CourseMeter")

for pn in ivalues(PlayerNumber) do
	-- stepping displays
	t[#t+1] = LoadActor(THEME:GetPathG("ScreenGameplay","StepInfo"),pn)..{
		Name="StepInfo"..PlayerNumberToString(pn);
		InitCommand=function(self)
			self:player(pn);
			ActorUtil.LoadAllCommandsAndSetXY(self,Var "LoadingScreen")
		end;
	};

	-- secondary scores
	t[#t+1] = LoadActor(THEME:GetPathG("ScreenGameplay","SecondaryScore"),pn)..{
		Name="SecondaryScore"..PlayerNumberToString(pn);
		InitCommand=function(self)
			self:player(pn);
			ActorUtil.LoadAllCommandsAndSetXY(self,Var "LoadingScreen")
		end;
	};
end

t[#t+1] = Def.Actor{
	Name="LifeMeterHack";
	BeginCommand=function(self)
		if not GAMESTATE:IsCourseMode() and GAMESTATE:IsSideJoined(PLAYER_2) then
			local sc = SCREENMAN:GetTopScreen()
			if sc then
				local lm = sc:GetChild("LifeP2")
				if lm then
					lm:GetChild("Stream"):zoomx(-1)
				end
			end
		end
	end;
};

return t